#!/bin/bash

#Company:       PowerCraft Technology
#Author:        Copyright Jelle de Jong <jelledejong@powercraft.nl>
#Note:          Please send me an email if you enhanced this script
#Version:       0.0.2
#Date:          05-09-2006
#System:        Xubuntu 7.10
#Information:   man cp
#Category       Thunar scripts (thunar->edit->custom actions)
#Name:          Copy to /media/disk
#Description:   Copy selected items to directory /media/disk
#Command:       xfce4-terminal --disable-server --hide-toolbars --execute /usr/share/pct-thunar-scripts/scripts/copy-to-disk.sh %F
#Patterns:      *
#Directories:   True
#Audio Files:   True
#Image Files:   True
#Text Files:    True
#Video Files:   True
#Other Files:   True

# Did the script work for you?
# Yes
# Yes, but with some errors
# Yes, but I had to change some things
# Not at all

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA.

cecho()
{
    if [ "$1" = "black" ]; then
        echo -ne "\E[30m"
    elif [ "$1" = "red" ]; then
        echo -ne "\E[31m"
    elif [ "$1" = "green" ]; then
        echo -ne "\E[32m"
    elif [ "$1" = "yellow" ]; then
        echo -ne "\E[33m"
    elif [ "$1" = "blue" ]; then
        echo -ne "\E[34m"
    elif [ "$1" = "magenta" ]; then
        echo -ne "\E[35m"
    elif [ "$1" = "cyan" ]; then
        echo -ne "\E[36m"
    fi

    echo "$2" "$3"
    tput sgr0
}

echo "copy these directory(s) or file(s):"
for I in "$@"
do
    cecho "blue" "$I"
done

for I in "$@"
do
    cecho "blue" "starting with: "
    echo "$I"

    cp -a "$I" /media/disk

    if [ $? -eq 1 ]
    then
        cecho "red" "retry with superuser rights"

        sudo cp -a "$I" /media/disk

        if [ $? -eq 1 ]
        then
            cecho "red" "error, exit in 30 seconds without success"
            sleep 30
            exit 1
        fi
    fi

    cecho "green" "completed with: "
    echo "$I"
done

cecho "blue" "---------------"
echo "done, closing after 10 seconds"
sleep 10

exit 0
