#!/bin/bash

#Company:       PowerCraft Technology
#Author:        Copyright Jelle de Jong <jelledejong@powercraft.nl>
#Note:          Please send me an email if you enhanced this script
#Version:       0.0.1
#Date:          20-03-2008
#System:        Debian, Xubuntu, Ubuntu
#Information:   man pdftk, man test
#Category       Thunar scripts
#Name:          DjVu Join
#Description:   Merge DjVu files
#Command:       xfce4-terminal --disable-server --hide-toolbars --execute /usr/share/pct-thunar-scripts/scripts/djvu-file-join.sh %F
#Patterns:      *.djvu; *.DJVU;
#Image Files:   True

# Did the script work for you?
# Yes
# Yes, but with some errors
# Yes, but I had to change some things
# Not at all

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA.

cecho()
{
    if [ "$1" = "black" ]; then
        echo -ne "\E[30m"
    elif [ "$1" = "red" ]; then
        echo -ne "\E[31m"
    elif [ "$1" = "green" ]; then
        echo -ne "\E[32m"
    elif [ "$1" = "yellow" ]; then
        echo -ne "\E[33m"
    elif [ "$1" = "blue" ]; then
        echo -ne "\E[34m"
    elif [ "$1" = "magenta" ]; then
        echo -ne "\E[35m"
    elif [ "$1" = "cyan" ]; then
        echo -ne "\E[36m"
    fi

    echo $2 $3
    tput sgr0
}

cecho "magenta" "processing file(s): "
for I in "$@"
do
    filename="${I##*/}"
    cecho "blue" "$filename"
done

echo -n "are you sure you want to continue [Y/n]? "
read input
if [ "$input" = "n" ]
then
    exit 0
fi

#whereis djvm
if [ ! -e /usr/bin/djvm  ]
then
    cecho "red" "djvm not found, installing now"
    sudo apt-get install djvulibre-bin
fi

join_djvu()
{
    file="$I"
    if [ -e document-multi-page.djvu ] && [ -e "$file" ]
    then
        djvm -insert document-multi-page.djvu "$file"
    else
        djvm -create document-multi-page.djvu "$file"
    fi
}

for I in "$@"
do
    filename="${I##*/}"
    cecho "green" "starting with: "
    cecho "blue" "$filename"

    filetype=`file -b "$I" | cut -f 1 -d ","`
    cecho "green" "file type is: "
    echo "$filetype"

    join_djvu "$I"

    cecho "green" "completed with: "
    cecho "blue" "$filename"
    cecho "blue" "---------------"
done

echo "done, closing after 25 seconds"
sleep 25

exit 0
