#!/bin/bash

#Author:        Copyright Jelle de Jong <jelledejong@powercraft.nl>
#Note:          Please send me an email if you enhanced this script
#Version:       0.0.3
#Date:          04-12-2006 / 28-04-07 / 22-10-07
#System:        Xubuntu 7.10
#Information:   http://www.mozilla.org/docs/command-line-args.html#Syntax_Rules
#Category       Thunar scripts
#Name:          Send Mail
#Description:   Send mail with selected files as attachments in thunderbird
#Command:       xfce4-terminal --disable-server --hide-toolbars --execute /usr/share/pct-thunar-scripts/scripts/send-mail.sh %F
#Patterns:      *
#Directories:   True
#Audio Files:   True
#Image Files:   True
#Text Files:    True
#Video Files:   True
#Other Files:   True

# Did the script work for you?
# Yes
# Yes, but with some errors
# Yes, but I had to change some things
# Not at all

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA.

cecho()
{
    if [ "$1" = "black" ]; then
        echo -ne "\E[30m"
    elif [ "$1" = "red" ]; then
        echo -ne "\E[31m"
    elif [ "$1" = "green" ]; then
        echo -ne "\E[32m"
    elif [ "$1" = "yellow" ]; then
        echo -ne "\E[33m"
    elif [ "$1" = "blue" ]; then
        echo -ne "\E[34m"
    elif [ "$1" = "magenta" ]; then
        echo -ne "\E[35m"
    elif [ "$1" = "cyan" ]; then
        echo -ne "\E[36m"
    fi

    echo $2 $3
    tput sgr0
}

echo "processing file(s):"
for I in "$@"
do
    cecho "blue" "$I"
done

for I in "$@"
do
    cecho "green" "starting with:"
    echo "$I"

    dirname=${I%/*}
    file=${I##*/}
    filename=${I##*/}; filename=${filename%.*}
    extension=${I##*.}

    body_query+="$file"$'\n'
    subject_query="$filename"

    if [ -f "$I" ]
    then
        cecho "blue" "Add regular file to attachment query"
        if [ "$attachment_query" != "" ]
        then
            attachment_query+=","
        fi
        attachment_query+="file://$I"
    else
        cecho "red" "Selection is not a regular file"
    fi

    cecho "green" "completed"
    cecho "blue" "---------------"
done

if [ "$attachment_query" != "" ]
then
    attachment="'$attachment_query'"
    subject="'$subject_query'"
    body=$'This message contains the following attachment(s):\n'"${body_query}"
    cecho "blue" "Command: thunderbird --compose \"subject=$subject,attachment=$attachment,body=$body\""
    [ -e /usr/bin/icedove ] && application="icedove"
    [ -e /usr/bin/thunderbird ] && application="thunderbird"
    $application --compose "subject=$subject,attachment=$attachment,body=$body"
fi

cecho "green" "done, closing after 10 seconds"

sleep 10

exit 0
